#include <corlib.h>
#include <winop.h>
#include <parts.h>
#include <mm_alloc.h>
#include <string.h>


/* qEBhE̐ÓIf[^ */
typedef struct{
	int	done;
	UGraphic	*ug;
	Sheet	sh;
	int	y;
	short	*gosa;
	char	*title;
} ChildData;

#define WAIT	5

/* ꂪƃAhXG[o(^^;; */
int	WindowHeapSize=64*1024;

int	Count=0;	/* NĂqEBhE̐ */
int	WinX=10,WinY=10;

static int	g_switch= FALSE;
static int	d_switch= FALSE;
static int	s_switch= FALSE;
static int	m_switch= FALSE;
short int	whitejump= 24, raster= 12;
static Sheet	edge_view;

static	short	dubarrow1[] = {
	0xFFEF, 0xFFFF, 0xFFBF, 0xFFEF, 0xFFFF, 0xFFBF, 0xFF6F, 0xFFFF,
	0xBFBF, 0xFC6F, 0xFFFF, 0x8FBF, 0xF06F, 0xFFFF, 0x87BF, 0xC06F,
	0xFFFF, 0x81BF, 0xE06F, 0xFFFF, 0x80BF, 0xF86F, 0xFFFF, 0x83BF,
	0xFC6F, 0xFFFF, 0x8FBF, 0xFF6F, 0xFFFF, 0xBFBF, 0xFFEF, 0xFFFF,
	0xFFBF, 0x800F, 0xFFFE, 0x003F
};
static	short	dubarrow2[] = {
	0xFFE0, 0x0003, 0xFF80, 0x8000, 0x0002, 0x0000, 0x8000, 0x0002,
	0x0000, 0x8000, 0x0002, 0x0000, 0x8000, 0x0002, 0x0000, 0x8000,
	0x0002, 0x0000, 0x8000, 0x0002, 0x0000, 0x8000, 0x0002, 0x0000,
	0x8000, 0x0002, 0x0000, 0x8000, 0x0002, 0x0000, 0x8000, 0x0002,
	0x0000, 0x8000, 0x0002, 0x0000
};
static Sheet	dubarrow = { 42, 12, 3, dubarrow1, dubarrow2 };

static char	numtmp[4]= "\0";
static char	*menu[]= {	"Dither  Sheet",
						"Espread Sheet",
						"",
						"Dither  Mono",
						"Espread Mono"
};

extern int	g2sh(UGraphic *ug,Sheet *sh,int sy,int dy);
extern int	g2sh_x(UGraphic *ug,Sheet *sh,int sx,int dy,short *gosa);
extern int	g2m(UGraphic *ug,Sheet *sh,int sy,int dy);
extern int	g2m_x(UGraphic *ug,Sheet *sh,int sx,int dy,short *gosa);
extern UGraphic	*load_ug(char *name);

static int	ChildExec(WindowID,EventInfo*);
static WindowID	ChildNew(char *,UGraphic *ug);

static int
popupmenu( wp, info )
WindowID	wp;
EventInfo	*info;
{
	int	n, px, py;

	WindowGetScreenPosition( wp, &px, &py );
	px+= info->x;
	py+= info->y;
	n= PopUpMenu( px-1, py, menu, sizeof menu/sizeof(char*), 12 );
	switch( n ){
	case 0:
		m_switch= FALSE;
		d_switch= FALSE;
		break;
	case 1:
		m_switch= FALSE;
		d_switch= TRUE;
		break;
	case 3:
		m_switch= TRUE;
		d_switch= FALSE;
		break;
	case 4:
		m_switch= TRUE;
		d_switch= TRUE;
		break;
	default:
		return TRUE;
	}
	WindowRedraw( wp );
	return  TRUE;
}



/*-----------------------------------------------------------*/
/* qWindowǗ */

struct wnode{
	WindowID	wp;
	struct wnode	*next;
};

struct wnode	wbase;

static int	AddNode(WindowID wp){
	struct wnode	*pnode= &wbase;

	while(pnode->next!=NULL)	pnode=pnode->next;

	pnode->next= malloc( sizeof(struct wnode) );
	pnode= pnode->next;
	pnode->wp= wp;
	pnode->next= NULL;
	return TRUE;
}

static int	DelNode(WindowID wp){
	struct wnode *pnode,*tnode;

	tnode= &wbase;
	pnode= wbase.next;

	while( pnode ){
		if( pnode->wp == wp ){
			tnode->next= pnode->next;
			free( pnode );
			return TRUE;
		}
		tnode= pnode;
		pnode= pnode->next;
	}
	return FALSE;
}
/*-----------------------------------------------------------*/

/* UserGraphic\̂̃Rs[𐶐 */
static UGraphic	*makeUGcopy( UGraphic *ug ){
	UGraphic	*t;

	if( !( t= malloc( sizeof( UGraphic ) ) ) )	return NULL;
	t->h= ug->h;
	t->v= ug->v;
	t->color= ug->color;

	switch( ug->color ){
		case WindowAttrGraphic65536:
			if( !( t->buf= malloc( t->h * t->v * 2 ) ) ){
				free( t );
				return NULL;
			}
			memcpy( t->buf, ug->buf, t->h * t->v * 2 );
			t->palet= NULL;
			break;

		case WindowAttrGraphic16:
			if( !( t->buf= malloc( t->h * t->v ) ) ){
				free( t );
				return NULL;
			}
			memcpy( t->buf, ug->buf, t->h * t->v );
			if( !( t->palet= malloc( 16 * 2 ) ) ){
				free( t->buf );
				free( t );
				return NULL;
			}
			memcpy( t->palet, ug->palet, 16 * 2 );
			break;

		case WindowAttrGraphic256:
			if( !( t->buf= malloc( t->h * t->v ) ) ){
				free( t );
				return NULL;
			}
			memcpy( t->buf, ug->buf, t->h * t->v );
			if( !( t->palet= malloc( 256 * 2 ) ) ){
				free( t->buf );
				free( t );
				return NULL;
			}
			memcpy( t->palet, ug->palet, 256 * 2 );
			break;
		default:
			;
	}
	return t;
}

static WindowID	LoadGFile(char *name){
	UGraphic	*ug2;
	WindowID	wt;

	//̓t@CƂĉ߂ł邩ǂ肵ǂ.
	ConsoleOpen();
	ConsolePrintf( "G2sh: Loading file: %s\n", name );
	if( ug2= load_ug( name ) ){
		if( wt= ChildNew( name, ug2 ) )	return wt;
		ConsolePrint( "܂.\n" );
		return FALSE;
	}
	ConsolePrint( "[hɎs܂.\n" );
	return FALSE;
}


static int	MainExec(WindowID wp,EventInfo *info){
	DrawBuf	dbuf[5], *dp= dbuf;
	char	color[8], mode[6];

	switch(info->option){
		case EventOpen:
			WindowSetEventAttr(wp,EventAttrDefault|EventUserON);
			WindowRedraw(wp);
			return TRUE;

		case EventClose:
			{
				struct wnode	*pnode;
				EventInfo	inf;
				WindowID	wt;

				pnode= wbase.next;
				while( pnode ){
					wt= pnode->wp;	/* pnodeCloseCxgŉĂ܂. */
					pnode= pnode->next;
					inf.option= EventClose;
					WindowSendEvent( wt, &inf );
				}
			}
			if( !Count ){
				WindowClose( wp );
				WindowConnectionClose();
				return TRUE;
			}
			return FALSE;

		case EventRedraw:
			DrawSetClear( dp++, 1 );
			if( d_switch ){
				strcpy( color, "Espread" );
			}else {
				strcpy( color, "Dither" );
			}
			DrawSetSymbol( dp++, 3, 0, color, AttrDefault, 12 );
			if( m_switch ){
				strcpy( mode, "Mono" );
				DrawSetPut( dp++, 33, 12, &dubarrow );
				itoa( whitejump, &numtmp, 10 );
				DrawSetSymbol( dp++, 60 - strlen( numtmp ) * 6, 12,
								numtmp, AttrDefault, 12 );
			}else {
				strcpy( mode, "Sheet" );
			}
			DrawSetSymbol( dp++, 3, 12, mode, AttrDefault, 12 );
			WindowDraw( wp, dbuf, dp-dbuf );
			return TRUE;

		case EventMouseSwitch:
			if( info->LeftON && info->y > 12 ){
				//ۂɂ͂ŃR\[ɐoƗǂ
				if( m_switch ){
					if( info->x >= 63 && info->x <= 74 ){
						if( ++whitejump > 48 ){
							whitejump= 48;
						}
					}else
						if( info->x >= 33 && info->x <= 44 ){
							if( --whitejump<0 ){
								whitejump= 0;
							}
					}else
						return TRUE;
					itoa( whitejump, &numtmp, 10 );
					DrawSetLine( dp++, 48, 12, 59, 23, 1, OptionFill );
					DrawSetSymbol( dp++, 60 - strlen( numtmp ) * 6, 12,
									numtmp, AttrDefault, 12 );
					WindowDraw( wp, dbuf, dp-dbuf );
				}
				return TRUE;
			}
			if( info->RightON ){
				popupmenu( wp, info );
				return TRUE;
			}
			return FALSE;

		case EventUser:
			switch(info->ComData){
				case UserGraphic:
				{
					UGraphic	*ug,*ug2;

					ug= info->ComBuffer;
					if( ug2 = makeUGcopy( ug ) ){
						switch( ug->color ){
						case WindowAttrGraphic65536:
							if( ChildNew( "UserGraphic64k", ug2 ) )	return TRUE;
							break;

						case WindowAttrGraphic256:
							if( ChildNew( "UserGraphic256", ug2 ) )	return TRUE;
							break;

						case WindowAttrGraphic16:
							if( ChildNew( "UserGraphic16", ug2 ) )	return TRUE;
							break;
						}
						free( ug2->buf );
						if( ug2->palet )	free( ug2->palet );
						free( ug2 );
					}
					ConsoleOpen();
					ConsolePrint("\n܂.\n");
					return FALSE;
				}
				
				case UserString:
					return (int)LoadGFile( (char *)info->ComBuffer);

				case UserStrings:
				{
					int	i;

					for( i= 0; *((char **)info->ComBuffer + i); ++i ){
						LoadGFile( *((char **)info->ComBuffer + i) );
					}
					return TRUE;
				}
				default:
					;
			}
			return FALSE;
		/*
		case EventIconify:
			IconEnt( wp, "G2Sheet v1.00", AttrDefault|AttrHighLight, 12 );
			return TRUE;
		*/
		default:
			return FALSE;
	}
}

static WindowID ChildNew( char *title, UGraphic *ug ){
	WindowID	wp;
	ChildData	*t;

	/* ̊m */
	if( !(t= malloc( sizeof( ChildData ) ) ) )	return NULL;
	t->ug= ug;	/* UG͊mۂĂ. */
	t->sh.h= ug->h;
	t->sh.v= ug->v;
	t->sh.hword= ( ug->h + 15 ) >> 4;
	if( !( t->sh.buf1= calloc( t->sh.hword * t->sh.v * 2 * 2, 1 ) ) ){
		free( t );
		return NULL;
	}
	t->sh.buf2= t->sh.buf1 + t->sh.hword * t->sh.v;
	t->y= 0;
	t->done= FALSE;

	if( !( t->title= malloc( strlen( title ) + 1 ) ) ){
		free( t->sh.buf1 );
		free( t );
		return NULL;
	}
	strcpy( t->title, title );

	if( d_switch && ug->color == WindowAttrGraphic65536 ){
		if( !( t->gosa= calloc( ( ug->h + 2 ) * 2 * sizeof( short ), 1 ) ) ){
			free( t->title );
			free( t->sh.buf1 );
			free( t );
			return NULL;
		}
	}else t->gosa= NULL;

	wp= WindowTitleOpen( WinX, WinY, ug->h, ug->v, NULL,
						title, Push|Close|Icon,ChildExec );
	++Count;

	/* gpubNNCAgf[^Ƃēo^ */
	WindowSetClientData( wp, 0, t );

	WindowRedraw( wp );
	return wp;
}

static int	ChildExec( WindowID wp, EventInfo *info ){
	DrawBuf	dbuf[2];
	ChildData	*my;
	static int	Time;
	int	vy, hwy;

	my= WindowGetClientPointer( wp );
	switch( info->option ){
		case EventOpen:
			AddNode( wp );
			WindowSetEventAttr( wp, EventAttrDefault|EventIntervalON );
			return TRUE;

		case EventClose:
			/* ̉ */
			DelNode( wp );

			if( my->ug ){
				free( my->ug->buf );
				if( my->ug->palet )	free( my->ug->palet );
				free( my->ug );
			}

			if( my->gosa )	free( my->gosa );

			free( my->sh.buf1 );

			free( my->title );

			free( my );

			WindowClose( wp );
			--Count;
			return TRUE;

		case EventRedraw:
			if( s_switch && !g_switch && !my->done ){
				if( m_switch ){
					if(d_switch)	g2m_x( my->ug, &my->sh, 0,
											my->ug->v - 1, my->gosa );
					else			g2m( my->ug, &my->sh, 0,
											my->ug->v - 1 );
					my->done= TRUE;
				}else {
					if(d_switch)	g2sh_x( my->ug, &my->sh, 0,
											my->ug->v - 1, my->gosa );
					else			g2sh( my->ug, &my->sh, 0,
											my->ug->v - 1 );
					my->done= TRUE;
				}
			}
			DrawSetPut( dbuf, 0, 0, &my->sh );
			WindowDraw( wp, dbuf, 1 );
			return TRUE;

		case EventMouseSwitch:
			if( info->LeftON ){
				UserSendOperation( wp, info,UserSheet, &my->sh );
				return TRUE;
			}
			if( info->RightON && g_switch ){
				UserSendOperation( wp, info,UserGraphic, my->ug );
				return TRUE;
			}
			return FALSE;

		case EventInterval:
			if( IntervalWait( WAIT, &Time ) ){
				if( !my->done ){
					hwy= my->sh.hword * my->y;
					if( m_switch ){
						if( d_switch && my->ug->color == WindowAttrGraphic65536 ){
							vy= raster;
							g2m_x( my->ug, &my->sh, my->y, my->y + vy - 1, my->gosa );
						}else{
							vy= raster * 2;
							g2m( my->ug, &my->sh, my->y, my->y + vy - 1 );
						}
					}else {
						if( d_switch && my->ug->color == WindowAttrGraphic65536 ){
							vy= raster;
							g2sh_x( my->ug, &my->sh, my->y, my->y + vy - 1, my->gosa );
						}else{
							vy= raster*2;
							g2sh( my->ug, &my->sh, my->y, my->y + vy - 1 );
						}
					}
					my->y+= vy;
					if( my->y >= my->ug->v )	my->done= TRUE;
					edge_view.h= my->sh.h;
					edge_view.v= vy;
					edge_view.hword= my->sh.hword;
					edge_view.buf1= my->sh.buf1+ hwy;
					edge_view.buf2= my->sh.buf2+ hwy;
					DrawSetPut( dbuf, 0, my->y-vy, &edge_view );
					WindowDraw( wp, dbuf, 1 );
				}else{
					if( !g_switch ){
						free( my->ug->buf );
						if( my->ug->palet )	free( my->ug->palet );
						free( my->ug );
						my->ug= NULL;
						
						if( my->gosa )	free( my->gosa );
						my->gosa= NULL;
					}
					/* C^[oIt */
					WindowSetEventAttr( wp, EventAttrDefault );
					WindowRedraw(wp);
				}
				return TRUE;
			}
			return FALSE;

		default:
			return FALSE;
	}
}

void WindowMain( int argc, char *argv[] ){
	WindowID	wp;
	EventInfo	inf;
	int	i;
	char	buff[256];

	argc=AnalyzeArgs( argc, argv, &WinX, &WinY, NULL, NULL );
	wbase.next= NULL;

	wp= WindowTitleOpen( WinX, WinY, 75, 24, NULL,
						"g2sh", Push|Close,MainExec );
	for( i = 1; i < argc; ++i ){
		if( '-' == *argv[i] || '/' == *argv[i]){
			switch(*(argv[i]+1)){
				case 'g':
					g_switch= TRUE;
					break;
				case 'd':
					d_switch= TRUE;
					break;
				case 's':
					s_switch= TRUE;
					break;
				case 'm':
					m_switch= TRUE;
					break;
				case 'r':
					raster= atoi2( argv[i]+2 );
					if( raster <= 0 )	raster= 12;
					break;
				default:
					;
			}
		}
	}
	for( i= 1; i < argc; ++i ){
		if( '-' != *argv[i] && '/' != *argv[i] ){
			/* t@C̃[h */
			inf.option= EventUser;
			inf.ComData= UserString;
			PathGetFullName2( buff, argv[i] );
			inf.ComBuffer= buff;
			WindowSendEvent( wp, &inf );
		}
	}
}
