#include <corlib.h>
#include <wlib.h>
#include <parts.h>
#include <mm_alloc.h>
#include <stdio.h>

#define JPEGED	"jpeged.r"

/* JPEGt@C̏Ԃ. */
static int jpeg_info(char *name,int *x,int *y){
	FILE *fp;
	int c,size,xt,yt,done=0;
	
	if(!(fp=fopen(name,"rb")))	return 1;
	
	while(!done){
		c=fgetc(fp);
		if(feof(fp))	break;
		if(c==0xff){
			c=fgetc(fp);
			switch(c){
				case 0xd8:	/* JPEGf[^̊Jn */
					c=fgetc(fp);
					c=fgetc(fp);
					break;
				case 0xc0:
				case 0xc2:
					c=fgetc(fp);
					size=c*256+fgetc(fp)-2;
					c=fgetc(fp);
					
					c=fgetc(fp);
					*y=c*256+fgetc(fp);
					
					c=fgetc(fp);
					*x=c*256+fgetc(fp);
					
					done=1;
					//fseek(fp,size-5,SEEK_CUR);
					break;
				default:
					c=fgetc(fp);
					size=c*256+fgetc(fp)-2;
					fseek(fp,size,SEEK_CUR);
					break;
			}
		}
	}
	fclose(fp);
	if(done)	return 0;
	else		return 1;
}

UGraphic *load_ug(char *name){
	int i,x,y;
	UGraphic *t;
	
	i=strlen(name)-4;
	
	/*
	̕Ŋgq𔻕ʂăt@CUGraphic\̂Ƀ[hĂ̂
	KɏΑΉtH[}bg𑝂₷Ƃo܂(^_-)
	t@C (char *name)ŗ^܂(tpXϊ
	*/
	
	/* JPEGt@C */
	if(0==strcmpi(name+i,".jpg")){
		char cline[256];
		
		if(jpeg_info(name,&x,&y))	return NULL;
		if(!(t=malloc(sizeof(UGraphic))))	return NULL;
		t->h=x;
		t->v=y;
		if(!(t->buf=malloc(x*y*2))){
			free(t); return NULL;
		}
		t->palet=NULL;
		t->color=WindowAttrGraphic65536;
		
		/* Ńobt@Ƀ[h. */
		sprintf(cline,"-L -VS%d,%d,$%x %s",(int)x,(int)y,(int)(t->buf),name);
		//WindowScreenQuit();
		WindowLoadExec(JPEGED,cline,NULL,ConsoleChar);
		WindowScreenInit();
		return t;
	}
	
	/* 
	if(0==strcmpi(name+i,".mag")){
		摜ɍ킹UGraphic\̂̊m.
		
		ۂ̉摜t->bufɃ[h
		
		16,256F摜̏ꍇt->paletmہEݒ肷
			16F̏ꍇ  t->palet=malloc( 16*sizeof(unsigned short))
			256F̏ꍇ t->palet=malloc(256*sizeof(unsigned short))
		65536F摜̏ꍇɂt->palet=NULLŗǂ.
		
		t->h,t->v,t->color̐ݒs.
		
		ӓ_: t->buf16,256F̏ꍇ 1Wordӂ2dotȂ̂ŁA[h[`ɂĂ
		        Ɨ̈Ƀ[hUGraphic`ɃRo[gKv(^^;;
		
		return t;	UGraphic\̂Ԃ.
		܂A[hɎsꍇNULLԂΗǂ.
		
		ŊmۂꂽUGraphic\̂-gIvVw肳ĂȂ茸FI
		ɉB郁͈ȉ̒ʂ
			t
			t->buf
			t->palet(!=NULL̏ꍇ̂)
	}
	*/
	
	return NULL;
}
