RUNS_HUMAN_VERSION	equ	3
	.cpu 68000

	.even
	.text

	.even
	.globl	_g2m
_g2m:
	link	a6,#-8		*local variable
	movem.l	d3-d7/a3-a5,-(sp)

	move.w	_whitejump(OPC),d3
	move.l	16(a6),d4	*source y

	move.l	12(a6),a3	*Sheet
	lea	8(a3),a0	*Sheet->hword
	move.l	(a0)+,d0	*Sheet->hword
	mulu	d4,d0
	add.l	d0,d0
	move.l	d0,d1
	add.l	(a0)+,d0	*Sheet->buf1
	movea.l	d0,a4
	add.l	(a0)+,d1	*Sheet->buf2
	movea.l	d1,a5

	movea.l	8(a6),a0	*ug
	move.w	6(a0),d0	*ug->v(word)
	subq.w	#1,d0
	move.w	22(a6),d1	*dy(word)
	cmp.w	d1,d0
	bge	@f

	move.w	d0,d1
@@
	sub.w	d4,d1		*yloop_counter= dy-sy
	lea.l	_multbl(OPC),a3
	moveq.l	#$3e,d5
	move.l	(a0),d0		*ug->h
	lsr.w	#4,d0
	move.w	d0,-6(a6)	*xword_loop_counter= ug->h / 16
	moveq.l	#3,d0
	and.w	18(a6),d0
 	lsl.w	#5,d0
	move.l	d0,-4(a6)	*bayer_offset= [sy & 3] * 32

	move.l	8(a0),d0	*ug->color(= mode )
	moveq.l	#12,d2
	cmp.l	d0,d2
	beq	g2m_65		*ug65536

	subq.l	#4,d0		*ug16
	beq	g2m_pal

	subq.l	#4,d0		*ug256
	bne	g2m_end		*other
g2m_pal:
	movea.l	12(a0),a2	*ug->buf
	move.l	(a0),d0		*ug->h
	move.w	d0,-8(a6)
*	lsr.w	#1,d0		*ug->h / 2
	mulu	d4,d0		*sy * ug->h / 2
*	add.l	d0,d0		*sy * ug->h (even)
	adda.l	d0,a2
	movea.l	16(a0),a0	*ug->palet
mp_ylp:
	move.w	-8(a6),d7	*ug->h
	move.w	-6(a6),d2	*ug->h / 16
	subi.w	#32,-2(a6)
	bge	@f

	move.w	#96,-2(a6)
@@
	swap.w	d1
mp_xlp:
	swap.w	d2
	lea	_bayer2(OPC),a1
	adda.l	-4(a6),a1
	moveq.l	#15,d6
mp_blp:
	subq.w	#1,d7
	blt	mp_break

	add.w	d4,d4
	clr.w	d0
	move.b	(a2)+,d0
	add.w	d0,d0
	move.w	(a0,d0.w),d0	*color code
	move.w	d0,d2
	and.w	d5,d2		*B0
	lsr.w	#5,d0
	move.w	d0,d1
	and.w	d5,d1		*R0
	lsr.w	#5,d0
	and.w	d5,d0		*G0
	move.w	64(a3,d0.w),d0
	add.w	(a3,d1.w),d0
	tas	d2
	add.w	(a3,d2.w),d0
	add.w	#128,d0
	lsr.w	#8,d0
	add.w	(a1)+,d0	*brightness
	cmp.w	d0,d3
	bgt	@f

	addq.w	#1,d4
@@
	dbra	d6,mp_blp
mp_break:
	tst.w	d6		*processed 16 pixels
	blt	mp_put

	cmp.w	#15,d6		*processed 0 pixel
	beq	@f

	addq.w	#1,d6
	lsl.l	d6,d4
mp_put:
	move.w	d4,(a4)+	*buf1
	move.w	d4,(a5)+	*buf2
@@
	swap.w	d2
	dbra	d2,mp_xlp

	swap.w	d1
	dbra	d1,mp_ylp

	bra	g2m_end
g2m_65:
	movea.l	12(a0),a2	*ug->buf
	move.l	(a0),d0		*ug->h
	mulu	d4,d0		*d4=sy
	add.l	d0,d0
	adda.l	d0,a2
m6_ylp:
	move.w	2(a0),d7	*ug->h
	subi.w	#32,-2(a6)
	bge	@f
	move.w	#96,-2(a6)
@@
	move.w	-6(a6),d2	*xword_loop_counter
	swap.w	d1
m6_xlp:
	swap.w	d2
	lea	_bayer2(OPC),a1
	adda.l	-4(a6),a1
	moveq.l	#15,d6		*xloop_counter init
m6_blp:
	subq.w	#1,d7
	blt	m6_break

	add.w	d4,d4
	move.w	(a2)+,d0	*color code
	move.w	d0,d2
	and.w	d5,d2		*B0
	lsr.w	#5,d0
	move.w	d0,d1
	and.w	d5,d1		*G0
	lsr.w	#5,d0
	and.w	d5,d0		*R0
	move.w	64(a3,d0.w),d0
	add.w	(a3,d1.w),d0
	tas	d2
	add.w	(a3,d2.w),d0
	add.w	#128,d0
	lsr.w	#8,d0
	add.w	(a1)+,d0	*brightness
	cmp.w	d0,d3
	bgt	@f

	addq.w	#1,d4
@@
	dbra	d6,m6_blp
m6_break:
	tst.w	d6		*processd 16 pixels
	blt	m6_put

	cmp.w	#15,d6		*processd 0 pixel
	beq	@f

	addq.w	#1,d6
	lsl.l	d6,d4
m6_put:
	move.w	d4,(a4)+	*buf1
	move.w	d4,(a5)+	*buf2
@@
	swap.w	d2
	dbra	d2,m6_xlp

	swap.w	d1
	dbra	d1,m6_ylp
g2m_end:
	moveq.l	#0,d0
	movem.l	(sp)+,d3-d7/a3-a5
	unlk	a6
	rts

	.even
	.globl	_g2m_x
_g2m_x:
	link	a6,#-10		*local variable
	movem.l	d3-d7/a3-a5,-(sp)

	move.w	_whitejump(OPC),d3
	add.w	d3,d3
	sub.w	#32,d3		*whitejump
	swap.w	d3

	move.l	12(a6),a3	*Sheet
	lea.l	8(a3),a0
	move.l	(a0)+,d0	*Sheet->hword
	move.l	16(a6),d4	*source y
	move.w	d4,d1
	mulu	d1,d0
	add.l	d0,d0
	move.l	d0,d1
	add.l	(a0)+,d0	* + Sheet->buf1
	move.l	d0,a4
	add.l	(a0)+,d1	* + Sheet->buf2
	move.l	d1,a5

	move.l	8(a6),a0	*ug
	move.l	(a0),d0		*ug->h
	move.w	d0,d1
	move.w	d0,d2
	lsr.w	#4,d1
	move.w	d1,-10(a6)	*ug->h / 16
	move.l	d4,d1		*source y
	mulu	d1,d2
	add.l	d2,d2
	move.l	12(a0),a3	*ug->buf
	adda.l	d2,a3

	movea.l	24(a6),a1	*gosa
	addq.w	#2,a1
	move.l	a1,-4(a6)	*gosatop
	add.l	d0,d0
	lea	4(a1,d0.l),a1
	move.l	a1,-8(a6)	*gosa2top

	move.l	(a0),d2		*ug->h
	swap.w	d2
	move.w	6(a0),d0	*ug->v(word)
	lea	_multbl(OPC),a0
	subq.w	#1,d0
	move.w	22(a6),d3	*dy(word)
	cmp.w	d3,d0
	bge	@f

	move.w	d0,d3
@@
	sub.w	d4,d3
	moveq.l	#-31,d5
	swap.w	d5
	andi.w	#1,d4
	beq	mx_ylp

	move.l	-4(a6),d0	*exchange gosatop and gosa2top
	move.l	-8(a6),-4(a6)
	move.l	d0,-8(a6)
mx_ylp:
	swap.w	d2
	move.w	d2,d7
	move.w	d2,d0
	swap.w	d2
	addq.w	#1,d0		*(ug->h + 2) - 1 = gosa2_clrlp_counter
	moveq.l	#0,d4
	movea.l	-8(a6),a1	*gosa2top
	movea.l	a1,a2
gosa2_clrlp:
	move.w	d4,(a2)+
	dbra	d0,gosa2_clrlp

	movea.l	-4(a6),a2	*gosatop
	move.w	-10(a6),d5	*xword_loop_counter
	swap.w	d3
mx_xlp:
	swap.w	d5
	moveq.l	#15,d6		*xbit_loop_counter
mx_blp:
	subq.w	#1,d7		*? ug->h == x
	blt	mx_break

	move.w	(a3)+,d0	*color code
	move.w	d0,d2
	and.w	#$3e,d2		*B0
	lsr.w	#5,d0
	move.w	d0,d1
	and.w	#$3e,d1		*R0
	lsr.w	#5,d0
	and.w	#$3e,d0		*G0
	move.w	64(a0,d0.w),d0
	add.w	(a0,d1.w),d0
	tas	d2
	add.w	(a0,d2.w),d0
	add.w	#128,d0
	lsr.w	#8,d0
	add.w	(a2)+,d0	*brightness
	move.w	d0,d1		*n
	add.w	d4,d4
	cmp.w	d3,d0
	blt	@f

	addq.w	#1,d4		*white
	add.w	d5,d1		*n-= 31
@@
	addq.w	#2,a1		*gosa2++
	move.w	d1,d0
	bge	@f

	addq.w	#7,d0
@@
	andi.w	#$fff8,d0	*nn= n % 8
	move.w	d1,d2
	sub.w	d0,d2
	tst.w	d1
	bge	@f

	addq.w	#1,d1
@@
	asr.w	#1,d1		*n/= 2
	move.w	(a2),d0		*g
	add.w	d1,d0		*t= *g + n
	cmpi.w	#31,d0
	ble	@f

	moveq.l	#31,d0
	bra	g0
@@
	cmp.w	d5,d0
	bge	g0

	move.w	d5,d0
g0:
	move.w	d0,(a2)		**g= t
	tst.w	d1
	bge	@f

	addq.w	#1,d1
@@
	asr.w	#1,d1		*n/= 2
	move.w	-4(a1),d0	*t= *gosa2 + n
	add.w	d1,d0
	cmpi.w	#31,d0
	ble	@f

	moveq.l	#31,d0
	bra	g1
@@
	cmp.w	d5,d0
	bge	g1

	move.w	d5,d0
g1:
	move.w	d0,-4(a1)	**(gosa2 - 2 )= t
	tst.w	d1
	bge	@f

	addq.w	#1,d1
@@
	asr.w	#1,d1		*n/= 2
	move.w	(a1),d0		*t= *gosa2 + n
	add.w	d1,d0
	cmpi.w	#31,d0
	ble	@f

	moveq.l	#31,d0
	bra	g2
@@
	cmp.w	d5,d0
	bge	g2

	move.w	d5,d0
g2:
	move.w	d0,(a1)		**gosa2= t
	add.w	-2(a1),d1	*t= *(gosa2 - 1) + n
	add.w	d2,d1		*t+= nn
	cmpi.w	#31,d1
	ble	@f

	moveq.l	#31,d1
	bra	g3
@@
	cmp.w	d5,d1
	bge	g3

	move.w	d5,d1
g3:
	move.w	d1,-2(a1)	**(gosa2 - 1)= t
	dbra	d6,mx_blp
mx_break:
	tst.w	d6		*processed 16 pixels
	blt	mx_put

	cmp.w	#15,d6		*processed 0 pixel
	beq	@f

	addq.w	#1,d6
	lsl.l	d6,d4
mx_put:
	move.w	d4,(a4)+	*buf1
	move.w	d4,(a5)+	*buf2
@@
	swap.w	d5
	dbra	d5,mx_xlp

	move.l	-4(a6),d0
	move.l	-8(a6),-4(a6)
	move.l	d0,-8(a6)
	swap.w	d3
	dbra	d3,mx_ylp

	moveq.l	#0,d0
	movem.l	(sp)+,d3-d7/a3-a5
	unlk	a6
	rts

	.even
	.end
