RUNS_HUMAN_VERSION	equ	3
	.cpu 68000

	.even
	.data

	.even
	.globl	_bayer2
_bayer2:
	.dc.w  9, 6,10, 5, 9, 6,10, 5, 9, 6,10, 5, 9, 6,10, 5
	.dc.w  1,14, 2,13, 1,14, 2,13, 1,14, 2,13, 1,14, 2,13
	.dc.w 11, 4, 8, 7,11, 4, 8, 7,11, 4, 8, 7,11, 4, 8, 7
	.dc.w  3,12, 0,15, 3,12, 0,15, 3,12, 0,15, 3,12, 0,15

	.even
	.globl	_multbl
_multbl:
	.dc.w	   0,   77,  154,  231,  308,  385,  462,  539
	.dc.w	 616,  693,  770,  847,  924, 1001, 1078, 1155
	.dc.w	1232, 1309, 1386, 1463, 1540, 1617, 1694, 1771
	.dc.w	1848, 1925, 2002, 2079, 2156, 2233, 2310, 2387
	.dc.w	   0,  151,  302,  453,  604,  755,  906, 1057
	.dc.w	1208, 1359, 1510, 1661, 1812, 1963, 2114, 2265
	.dc.w	2416, 2567, 2718, 2869, 3020, 3171, 3322, 3473
	.dc.w	3624, 3775, 3926, 4077, 4228, 4379, 4530, 4681
	.dc.w	   0,   28,   56,   84,  112,  140,  168,  196
	.dc.w	 224,  252,  280,  308,  336,  364,  392,  420
	.dc.w	 448,  476,  504,  532,  560,  588,  616,  644
	.dc.w	 672,  700,  728,  756,  784,  812,  840,  868

	.even
	.text

	.even
	.globl	_g2sh
_g2sh:
	link	a6,#-8		*local variable
	movem.l	d3-d7/a3-a5,-(sp)

	move.l	16(a6),d4	*source y
	moveq.l	#$3e,d3

	move.l	12(a6),a3	*Sheet
	lea	8(a3),a0	*Sheet->hword
	move.l	(a0)+,d0
	mulu	d4,d0		*hword * source y
	add.l	d0,d0
	move.l	d0,d1
	add.l	(a0)+,d0	*Sheet->buf1
	movea.l	d0,a4
	add.l	(a0)+,d1	*Sheet->buf2
	movea.l	d1,a5

	movea.l	8(a6),a0	*ug
	move.w	6(a0),d0	*ug->v(word)
	subq.w	#1,d0
	move.w	22(a6),d1	*dy(word)
	cmp.w	d1,d0
	bge	@f

	move.w	d0,d1
@@
	sub.w	d4,d1		*yloop_counter= dy-sy
	lea.l	_multbl(OPC),a3
	move.l	(a0),d0		*ug->h
	lsr.w	#4,d0
	move.w	d0,-6(a6)	*xword_loop_counter= ug->h / 16
	moveq.l	#3,d0
	and.w	18(a6),d0
 	lsl.w	#5,d0
	move.l	d0,-4(a6)	*bayer_offset= [sy & 3] * 32
	move.l	8(a0),d0	*ug->color(= mode )
	moveq.l	#12,d2
	cmp.l	d0,d2
	beq	s_65

	subq.l	#4,d0		*ug16
	beq	s_pal

	subq.l	#4,d0		*ug256
	bne	s_end
s_pal:
	movea.l	12(a0),a2	*ug->buf
	move.l	(a0),d0		*ug->h
	move.w	d0,-8(a6)
*	lsr.w	#1,d0		*ug->h / 2
	mulu	d4,d0
*	add.l	d0,d0		*ug->h * source y (even)
	adda.l	d0,a2
	movea.l	16(a0),a0	*ug->palet
sp_ylp:
	move.w	-8(a6),d7
	move.w	-6(a6),d2
	subi.w	#32,-2(a6)
	bge	@f

	move.w	#96,-2(a6)
@@
	swap.w	d1
sp_xlp:
	swap.w	d2
	lea	_bayer2(OPC),a1
	adda.l	-4(a6),a1
	moveq.l	#15,d6
sp_blp:
	subq.w	#1,d7
	blt	sp_break

	add.w	d4,d4
	add.w	d5,d5
	clr.w	d0
	move.b	(a2)+,d0	*color code
	add.w	d0,d0
	move.w	(a0,d0.w),d0
	move.w	d0,d2
	and.w	d3,d2		*B0
	lsr.w	#5,d0
	move.w	d0,d1
	and.w	d3,d1		*R0
	lsr.w	#5,d0
	and.w	d3,d0		*G0
	move.w	64(a3,d0.w),d0
	add.w	(a3,d1.w),d0
	tas	d2
	add.w	(a3,d2.w),d0
	add.w	#128,d0
	lsr.w	#8,d0
	add.w	(a1)+,d0	*brightness
	cmp.w	#29,d0
	bls	@f

	addq.w	#1,d4
	addq.w	#1,d5
	bra	lpent
@@
	cmp.w	#15,d0
	bls	lpent

	addq.w	#1,d4
lpent:
	dbra	d6,sp_blp
sp_break:
	tst.w	d6		*processed 16 pixels
	blt	sp_put

	cmp.w	#15,d6		*processed 0 pixel
	beq	@f

	addq.w	#1,d6
	lsl.l	d6,d4
	lsl.l	d6,d5
sp_put:
	move.w	d4,(a4)+	*buf1
	move.w	d5,(a5)+	*buf2
@@
	swap.w	d2
	dbra	d2,sp_xlp

	swap.w	d1
	dbra	d1,sp_ylp

	bra	s_end
s_65:
	movea.l	12(a0),a2	*ug->buf
	move.l	(a0),d0		*ug->h
	mulu	d4,d0		*ug->h * source y
	add.l	d0,d0
	adda.l	d0,a2
s6_ylp:
	move.w	2(a0),d7	*ug->h
	subi.w	#32,-2(a6)
	bge	@f

	move.w	#96,-2(a6)
@@
	move.w	-6(a6),d2	*xword_loop_counter
	swap.w	d1
s6_xlp:
	swap.w	d2
	lea	_bayer2(OPC),a1
	adda.l	-4(a6),a1
	moveq.l	#15,d6		*xloop_counter init
s6_blp:
	subq.w	#1,d7
	blt	s6_break

	add.w	d4,d4
	add.w	d5,d5
	move.w	(a2)+,d0	*color code
	move.w	d0,d2
	and.w	d3,d2		*B0
	lsr.w	#5,d0
	move.w	d0,d1
	and.w	d3,d1		*R0
	lsr.w	#5,d0
	and.w	d3,d0		*B0
	move.w	64(a3,d0.w),d0
	add.w	(a3,d1.w),d0
	tas	d2
	add.w	(a3,d2.w),d0
	add.w	#128,d0
	lsr.w	#8,d0
	add.w	(a1)+,d0	*brightness
	cmp.w	#29,d0
	bls	@f

	addq.w	#1,d4
	addq.w	#1,d5
	bra	?16
@@
	cmp.w	#15,d0
	bls	?16

	addq.w	#1,d4
?16:
	dbra	d6,s6_blp
s6_break:
	tst.w	d6		*processed 16 pixels
	blt	s6_put

	cmp.w	#15,d6		*processed 0 pixel
	beq	@f

	addq.w	#1,d6
	lsl.l	d6,d4
	lsl.l	d6,d5
s6_put:
	move.w	d4,(a4)+	*buf1
	move.w	d5,(a5)+	*buf2
@@
	swap.w	d2
	dbra	d2,s6_xlp

	swap.w	d1
	dbra	d1,s6_ylp
s_end:
	moveq.l	#0,d0
	movem.l	(sp)+,d3-d7/a3-a5
	unlk	a6
	rts

	.even
	.globl	_g2sh_x
_g2sh_x:
	link	a6,#-10		*local variable
	movem.l	d3-d7/a3-a5,-(sp)

	move.l	12(a6),a3	*Sheet
	lea.l	8(a3),a0
	move.l	(a0)+,d0	*Sheet->hword
	move.l	16(a6),d4	*source y
	move.w	d4,d1
	mulu	d1,d0		*hword * source y
	add.l	d0,d0
	move.l	d0,d1
	add.l	(a0)+,d0	* + Sheet->buf1
	move.l	d0,a4
	add.l	(a0)+,d1	* + Sheet->buf2
	move.l	d1,a5

	move.l	8(a6),a0	*ug
	move.l	(a0),d0		*ug->h
	move.w	d0,d1
	move.w	d0,d2
	lsr.w	#4,d1
	move.w	d1,-10(a6)	*ug->h / 16
	move.l	d4,d1
	mulu	d1,d2		*ug->h * source y
	add.l	d2,d2
	move.l	12(a0),a3	*ug->buf
	adda.l	d2,a3

	movea.l	24(a6),a1	*gosa
	addq.w	#2,a1
	move.l	a1,-4(a6)	*gosatop
	add.l	d0,d0
	lea	4(a1,d0.l),a1
	move.l	a1,-8(a6)	*gosa2top
	moveq.l	#-31,d3
	swap.w	d3

	move.w	6(a0),d0	*ug->v(word)
	subq.w	#1,d0
	move.w	22(a6),d3	*dy(word)
	cmp.w	d3,d0
	bge	@f

	move.w	d0,d3
@@
	sub.w	d4,d3
	andi.w	#1,d4
	beq	sx_ylp

	move.l	-4(a6),d0	*exchange gosatop and gosa2top
	move.l	-8(a6),-4(a6)
	move.l	d0,-8(a6)
sx_ylp:
	move.l	8(a6),a0	*ug
	move.l	(a0),d0		*ug->h
	move.w	d0,d7
	addq.w	#1,d0		*(ug->h + 2) - 1 = gosa2_clrlp_counter
	moveq.l	#0,d4
	movea.l	-8(a6),a1	*gosa2top
	movea.l	a1,a2
gosa2_clrlp:
	move.w	d4,(a2)+
	dbra	d0,gosa2_clrlp

	lea	_multbl(OPC),a0
	movea.l	-4(a6),a2	*gosatop
	move.w	-10(a6),d2	*xword_loop_counter
	swap.w	d3
sx_xlp:
	swap.w	d2
	moveq.l	#15,d6		*xbit_loop_counter
sx_blp:
	subq.w	#1,d7		*? ug->h == x
	blt	sx_break

	move.w	(a3)+,d0	*color code
	move.w	d0,d2
	and.w	#$3e,d2		*B0
	lsr.w	#5,d0
	move.w	d0,d1
	and.w	#$3e,d1		*R0
	lsr.w	#5,d0
	and.w	#$3e,d0		*G0
	move.w	64(a0,d0.w),d0
	add.w	(a0,d1.w),d0
	tas	d2
	add.w	(a0,d2.w),d0
	add.w	#128,d0
	lsr.w	#8,d0
	add.w	(a2)+,d0	*brightness
	move.w	d0,d1
	add.w	d4,d4
	add.w	d5,d5
	cmpi.w	#21,d0
	ble	@f

	addq.w	#1,d4
	addq.w	#1,d5
	add.w	d3,d1
	bra	spread
@@
	cmpi.w	#10,d0
	ble	spread

	addq.w	#1,d4
	subi.w	#15,d1
spread:
	addq.w	#2,a1
	move.w	d1,d0
	bge	@f

	addq.w	#7,d0
@@
	andi.w	#$fff8,d0	*n % 8
	move.w	d1,d2
	sub.w	d0,d2		*nn= n - nn
	tst.w	d1
	bge	@f

	addq.w	#1,d1
@@
	asr.w	#1,d1		*n/= 2
	move.w	(a2),d0		*t= *gosa
	add.w	d1,d0		*t+= n
	cmpi.w	#31,d0
	ble	@f

	moveq.l	#31,d0
	bra	g0
@@
	cmp.w	d3,d0
	bge	g0

	move.w	d3,d0
g0:
	move.w	d0,(a2)		**gosa= t
	tst.w	d1
	bge	@f
	addq.w	#1,d1
@@
	asr.w	#1,d1		*n/= 2
	move.w	-4(a1),d0	*t= *(gosa2 - 2)
	add.w	d1,d0		*t+= n
	cmpi.w	#31,d0
	ble	@f

	moveq.l	#31,d0
	bra	g1
@@
	cmp.w	d3,d0
	bge	g1

	move.w	d3,d0
g1:
	move.w	d0,-4(a1)	**(gosa2 - 2)= t
	tst.w	d1
	bge	@f

	addq.w	#1,d1
@@
	asr.w	#1,d1		*n/= 2
	move.w	(a1),d0		*t= *gosa2
	add.w	d1,d0		*t+= n
	cmpi.w	#31,d0
	ble	@f

	moveq.l	#31,d0
	bra	g2
@@
	cmp.w	d3,d0
	bge	g2

	move.w	d3,d0
g2:
	move.w	d0,(a1)		**gosa2= t
	add.w	-2(a1),d1	*t= *(gosa2 - 1) + n
	add.w	d2,d1		*t+= nn
	cmpi.w	#31,d1
	ble	@f

	moveq.l	#31,d1
	bra	g3
@@
	cmp.w	d3,d1
	bge	g3

	move.w	d3,d1
g3:
	move.w	d1,-2(a1)	**(gosa2 - 1)= t
	dbra	d6,sx_blp
sx_break:
	tst.w	d6
	blt	sx_put

	cmp.w	#15,d6
	beq	@f

	addq.w	#1,d6
	lsl.l	d6,d4
	lsl.l	d6,d5
sx_put:
	move.w	d4,(a4)+	*buf1
	move.w	d5,(a5)+	*buf2
@@
	swap.w	d2
	dbra	d2,sx_xlp

	move.l	-4(a6),d0
	move.l	-8(a6),-4(a6)
	move.l	d0,-8(a6)
	swap.w	d3
	dbra	d3,sx_ylp

	moveq.l	#0,d0
	movem.l	(sp)+,d3-d7/a3-a5
	unlk	a6
	rts

	.even
	.end
